﻿# Name: Velostrata vSphere Service Role
# Purpose: Create A vSphere vCenter Role for the Velostrata Service.
# Created: 04/09/2016
# Modified: 29/12/2016
# Author: Alon Pildus
# Created For: velostrata.com
# Version: 1.2

Write-Host "`nVelostrata vSphere Service Role" -foreground "Green"

# Login to vSphere vCenter

Import-Module VMware.VimAutomation.Core

Write-Host "`nLogin to vSphere vCenter" -foreground "Cyan"
	
    $VCIp = Read-Host "`nPlease enter vCenter ip"
    $vcUser = Read-Host "`nPlease enter vCenter Username"
    $vcPass = Read-Host "`nPlease enter vCenter Password" -AsSecureString
    $Local:temp = [Runtime.InteropServices.Marshal]::PtrToStringAuto([Runtime.InteropServices.Marshal]::SecureStringToBSTR($vcPass))

    Connect-VIServer $VCIp -User $vcUser -Password $Local:temp -WarningAction SilentlyContinue | out-null


Write-Host "`nPlease Wait... Creating the Velostrata vSphere Service Role" -foreground "Yellow"

$privs_for_vsphere_role=@(
'Enable methods',
'Disable methods',
'Licenses',
'Log event',
'Create snapshot',
'Remove snapshot',
'Revert to Snapshot',
'Rename Snapshot',
'Configure managedBy',
'Power On',
'Power Off',
'Low level file operations',
'Register extension',
'Unregister extension',
'Update extension',
'Allow virtual machine download',
'Allow disk access',
'Allow read-only disk access',
'Create task',
'Update task'
'Create alarm'
'Remove alarm'
'Set alarm status'
'Modify alarm')

New-VIRole -Name "Velostrata Service Role" -Privilege $privs_for_vsphere_role | out-null

Write-Host "`nVelostrata Service Role was created successfully" -foreground "Cyan"